(in-package :cl-uxn)

(deftype uint8 () '(unsigned-byte 8))
(deftype sint8 () '(byte 8))
(deftype uint16 () '(unsigned-byte 16))

(define-condition uxn-condition (condition)
  ((instance :initarg :instance :reader instance)))

(defun signify (value) (if (> value 127) (- value 256) value))
(defmacro setf-8 (symbol form) `(setf ,symbol (mod ,form #x100)))
(defmacro setf-16 (symbol form) `(setf ,symbol (mod ,form #x10000)))
(defun symbol-or-first (list)
  (mapcar (lambda (i) (if (listp i) (first i) i)) list))

(defun parse-define-instruction-args (list)
  (mapcar (lambda (i)
            (if (listp i)
                     `(,(first i) (get-value ,(second i)))
                     `(,i (get-value nil))))
          list))
